
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Story_document_linksDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const story_document_links = await db.story_document_links.create(
            {
                id: data.id || undefined,
        
        link_type: data.link_type
        ||
        null
            ,
            
        linked_at: data.linked_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await story_document_links.setStory( data.story || null, {
            transaction,
        });
        
        await story_document_links.setDocument( data.document || null, {
            transaction,
        });
        
        await story_document_links.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return story_document_links;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const story_document_linksData = data.map((item, index) => ({
                id: item.id || undefined,
                
                link_type: item.link_type
            ||
            null
            ,
            
                linked_at: item.linked_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const story_document_links = await db.story_document_links.bulkCreate(story_document_linksData, { transaction });

        // For each item created, replace relation files
        

        return story_document_links;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const story_document_links = await db.story_document_links.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.link_type !== undefined) updatePayload.link_type = data.link_type;
        
        
        if (data.linked_at !== undefined) updatePayload.linked_at = data.linked_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await story_document_links.update(updatePayload, {transaction});

        
        
        if (data.story !== undefined) {
            await story_document_links.setStory(
              
              data.story,
              
              { transaction }
            );
        }
        
        if (data.document !== undefined) {
            await story_document_links.setDocument(
              
              data.document,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await story_document_links.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return story_document_links;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const story_document_links = await db.story_document_links.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of story_document_links) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of story_document_links) {
                await record.destroy({transaction});
            }
        });


        return story_document_links;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const story_document_links = await db.story_document_links.findByPk(id, options);

        await story_document_links.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await story_document_links.destroy({
            transaction
        });

        return story_document_links;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const story_document_links = await db.story_document_links.findOne(
            { where },
            { transaction },
        );

        if (!story_document_links) {
            return story_document_links;
        }

        const output = story_document_links.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.story = await story_document_links.getStory({
            transaction
        });
        
        
        output.document = await story_document_links.getDocument({
            transaction
        });
        
        
        output.organizations = await story_document_links.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.user_stories,
        as: 'story',
        
        where: filter.story ? {
          [Op.or]: [
            { id: { [Op.in]: filter.story.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.story.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.documents,
        as: 'document',
        
        where: filter.document ? {
          [Op.or]: [
            { id: { [Op.in]: filter.document.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.document.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.linked_atRange) {
                const [start, end] = filter.linked_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    linked_at: {
                    ...where.linked_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    linked_at: {
                    ...where.linked_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.link_type) {
                where = {
                    ...where,
                link_type: filter.link_type,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.story_document_links.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'story_document_links',
                        'link_type',
                        query,
                    ),
                ],
            };
        }

        const records = await db.story_document_links.findAll({
            attributes: [ 'id', 'link_type' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['link_type', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.link_type,
        }));
    }

    
};

